from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import String, Float

Anvi_Script_Gen_Distribution_Of_Genes_In_A_Bin_V0_1_0 = CommandToolBuilder(tool="anvi_script_gen_distribution_of_genes_in_a_bin", base_command=["anvi-script-gen-distribution-of-genes-in-a-bin"], inputs=[ToolInput(tag="in_contigs_db", input_type=String(optional=True), prefix="--contigs-db", doc=InputDocumentation(doc="Anvi'o contigs database generated by 'anvi-gen-\ncontigs'")), ToolInput(tag="in_profile_db", input_type=String(optional=True), prefix="--profile-db", doc=InputDocumentation(doc="Anvi'o profile database")), ToolInput(tag="in_collection_name", input_type=String(optional=True), prefix="--collection-name", doc=InputDocumentation(doc="Collection name.")), ToolInput(tag="in_bin_id", input_type=String(optional=True), prefix="--bin-id", doc=InputDocumentation(doc="Bin name you are interested in.")), ToolInput(tag="in_min_detection", input_type=Float(optional=True), prefix="--min-detection", doc=InputDocumentation(doc="For this entire thing to work, the genome you are\nfocusing on should be detected in at least one\nmetagenome. If that is not the case, it would mean\nthat you do not have any sample that represents the\nniche for this organism (or you do not have enough\ndepth of coverage) to investigate the detection of\ngenes in the environment. By default, this script\nrequires at least '0.5' of the genome to be detected\nin at least one metagenome. This parameter allows you\nto change that. 0 would mean no detection test\nrequired, 1 would mean the entire genome must be\ndetected.")), ToolInput(tag="in_fraction_of_median_coverage", input_type=Float(optional=True), prefix="--fraction-of-median-coverage", doc=InputDocumentation(doc="The value set here will be used to remove a gene if\nits total coverage across environments is less than\nthe median coverage of all genes multiplied by this\nvalue. The default is 0.25, which means, if the median\ntotal coverage of all genes across all samples is\n100X, then, a gene with a total coverage of less than\n25X across all samples will be assumed not a part of\nthe 'environmental core'.\n"))], outputs=[], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Anvi_Script_Gen_Distribution_Of_Genes_In_A_Bin_V0_1_0().translate("wdl", allow_empty_container=True)

